#include <stdio.h>

#include <sys/types.h>
#include <sys/socket.h>
#include <sys/poll.h>

#include <sys/types.h>
#include <sys/ipc.h>
#include <sys/sem.h>

int accept_pure(int fd,char *message){
	int sfd, i = sizeof(struct sockaddr);
	struct sockaddr sin;
	
	zend_printf("accepting connections on fd=%d\n<br>\n",fd);
	fflush(stdin);
	
	do {
		sfd = accept(fd,(struct sockaddr*)&sin,&i);
		if(sfd < 0){
			zend_printf("ERROR ACCEPTING CONNECTION, wrong descriptor"
				" or maybe descriptor is unavailable\n");
			return -1;
		}
		hijack_handler(message,strlen(message),sfd);
		close(sfd);
	} while(ENDLESS_LOOP);
	zend_printf("finished\n<br>\n");
	return 0;
}

int accept_sem(int fd,char *message, int semaforid){
	int sfd, i = sizeof(struct sockaddr);
	struct sockaddr sin;
	struct sembuf semafor[2];
	struct pollfd bazen[2];

	semafor[0].sem_num  = 0;
	semafor[0].sem_op  = -1;
	semafor[0].sem_flg = 4096;

	bazen[0].fd = 4;
	bazen[0].events=POLLIN;
	bazen[0].revents=POLLIN;

	bazen[1].fd = 3;
	bazen[1].events=POLLIN;
	bazen[1].revents=POLLIN;

	zend_printf("accepting connections on fd=%d semid=%d\n<br>\n",fd,semaforid);
	fflush(stdin);
	
	do {
		semafor[0].sem_op  = -1;

		semop(semaforid,semafor,1);
		poll(bazen,2,-1);
		sfd = accept(fd,(struct sockaddr*)&sin,&i);

		if(sfd < 0){
			zend_printf("ERROR ACCEPTING CONNECTION, wrong descriptor"
				" or maybe descriptor is unavailable\n");
			return -1;
		}
		hijack_handler(message,strlen(message),sfd);
		close(sfd);

		semafor[0].sem_op  = 1;
		semop(semaforid,semafor,1);
	} while(ENDLESS_LOOP);
	zend_printf("finished\n<br>\n");

	return 0;
}
